from random import randint
from pythonsnake.snake import Snake


class Candy:
    def __init__(self, grid_width: int, grid_height: int, snake: Snake) -> None:
        self.X = 0
        self.Y = 0
        self.random_coord(grid_width, grid_height, snake)

    def random_coord(
        self, grid_width: int, grid_height: int, snake: Snake
    ) -> None:
        found = False
        x = 0
        y = 0
        while not found:
            correct = True
            x = self.random_coord_X(grid_width, snake)
            y = self.random_coord_Y(grid_height, snake)
            # candy can be on the same line or on the same column but not at
            # the exact same place as the snake
            for snake_part in snake.coord:
                if snake_part["x"] == x and snake_part["y"] == y:
                    correct = False
                    break

            if correct:
                found = True

        self.X = x
        self.Y = y

    def random_coord_X(self, grid_width: int, snake: Snake) -> int:
        return randint(0, grid_width-1)

    def random_coord_Y(self, grid_height: int, snake: Snake) -> int:
        return randint(0, grid_height-1)

    def new_coord(
        self, grid_width: int, grid_height: int, snake: Snake
    ) -> None:
        self.random_coord(grid_width, grid_height, snake)
