from pythonsnake.model import Game
from pythonsnake.terminalview import TerminalView
import keyboard
import time


class Controller:
    def __init__(self) -> None:
        self.view = TerminalView()
        self.game = None

    def game_menu(self) -> None:
        while True:
            self.start_game(self.choose_mode())

    def choose_mode(self) -> int:
        self.view.menu()

        choice = None
        while choice != "1" and choice != "2":

            choice = input("=>")
            if choice != "1" and choice != "2":
                self.view.menu_choice_incorrect()

        if choice == "2":
            exit()

        return int(choice)

    def start_game(self, mode: int) -> None:
        #TODO: detect console size of the user 
        self.game = Game(50, 25)

        if mode == 1:
            self.start_game_terminal()

    def start_game_terminal(self) -> None:

        keyboard.unhook_all()
        self.listen_escape_game()
        self.listen_move()
        
        while not self.game.lost:
            self.view.display_grid(
                self.game.move(self.game.current_direction + " arrow")
            )
            
            continue

        time.sleep(1)
        keyboard.unhook_all()

    def listen_escape_game(self) -> None:
        keyboard.on_press_key("esc", lambda _: self.game.exit_game())

    def listen_move(self) -> None:

        keyboard.on_press_key("left arrow", lambda _: self.view.display_grid(self.game.move("left arrow")))
        keyboard.on_press_key("right arrow", lambda _: self.view.display_grid(self.game.move("right arrow")))
        keyboard.on_press_key("up arrow", lambda _: self.view.display_grid(self.game.move("up arrow")))
        keyboard.on_press_key("down arrow", lambda _: self.view.display_grid(self.game.move("down arrow")))
     