from copy import deepcopy


class Snake:
    def __init__(self) -> None:
        self.coord = []
        self.coord.append({"x": 0, "y": 0})
        self.piece_pending = None

    def eat_candy(self) -> None:
        self.piece_pending = {
            "x": self.coord[-1]["x"],
            "y": self.coord[-1]["y"],
        }

    def move(self, direction) -> None:
        snake_to_shift = deepcopy(self.coord)

        # move the snake head
        if direction == "left arrow":
            self.coord[0]["x"] -= 1
        elif direction == "right arrow":
            self.coord[0]["x"] += 1
        elif direction == "up arrow":
            self.coord[0]["y"] -= 1
        elif direction == "down arrow":
            self.coord[0]["y"] += 1

        # move the body
        for i, piece in enumerate(snake_to_shift):
            # except the snake head
            if i != 0:
                self.coord[i] = {
                    "x": snake_to_shift[i - 1]["x"],
                    "y": snake_to_shift[i - 1]["y"],
                }

        if self.piece_pending != None:
            self.coord.append(
                {"x": self.piece_pending["x"], "y": self.piece_pending["y"]}
            )
            self.piece_pending = None
