from pythonsnake.model import Game
from pythonsnake import terminalColor
import os


class TerminalView:
    def __init__(self) -> None:
        self.in_progress = False

    def cls(self) -> None:
        os.system("cls" if os.name == "nt" else "clear")

    def display_grid(self, gameState: Game) -> None:
        if(self.in_progress == True):
            return None
        
        self.in_progress = True
        grid_to_print = ""
        for Y, line in enumerate(gameState.grid):

            # if first row, display the top border
            if Y == 0:
                grid_to_print += "_" * len(line)
                grid_to_print += "\n"

            for X, column in enumerate(line):
                # if left border, display border
                if X == 0:
                    grid_to_print += "|"

                # display user
                if column["snake"] == True:
                    grid_to_print += (
                        terminalColor.OKGREEN + "X" + terminalColor.ENDC
                    )
                # display candy except if same coord as player
                elif column["candy"] == True:
                    grid_to_print += (
                        terminalColor.OKBLUE + "O" + terminalColor.ENDC
                    )
                else:
                    grid_to_print += " "

                # if right border, display border
                if X == len(line) - 1:
                    grid_to_print += "|\n"

            # if last row, display the bottom border
            if Y == len(gameState.grid) - 1:
                grid_to_print += "\u203E" * len(line)
                grid_to_print += "\n"

        if gameState.lost:
            grid_to_print += (
                terminalColor.FAIL
                + terminalColor.BOLD
                + terminalColor.UNDERLINE
                + "Vous avez perdu !!!"
                + terminalColor.ENDC
                + "\n"
            )

        grid_to_print += (
            terminalColor.OKCYAN
            + "pour revenir au menu, appuyer sur la touche (Esc)"
            + terminalColor.ENDC
            + "\n"
        )

        grid_to_print += (
            terminalColor.OKBLUE
            + "Longueur: "
            + str(len(gameState.snake.coord))
            + terminalColor.ENDC
        )
        self.cls()
        print(grid_to_print, end="\r")
        self.in_progress = False

    def menu(self) -> None:
        self.cls()
        menu = (
            terminalColor.OKGREEN
            + terminalColor.BOLD
            + "Bienvenue dans python Snake"
            + terminalColor.ENDC
            + "\n"
            + "que souhaitez vous faire:\n"
            + "1) jouer dans la console\n"
            + "2) Quitter\n"
        )
        print(menu, end="\r")

    def menu_choice_incorrect(self) -> None:
        print(
            terminalColor.FAIL, "le choix n'est pas correct", terminalColor.ENDC
        )
